3 # Copyright (c) 2006 Eric Wong
9 git instaweb [options] (--start | --stop | --restart)
11 l,local only bind on 127.0.0.1
12 p,port= the port to bind to
13 d,httpd= the command to launch
14 b,browser= the browser to launch
15 m,module-path= the module path (only needed for apache2)
17 stop stop the web server
18 start start the web server
19 restart restart the web server
25 local="$(git config --bool --get instaweb.local)"
26 httpd="$(git config --get instaweb.httpd)"
27 port=$(git config --get instaweb.port)
28 module_path="$(git config --get instaweb.modulepath)"
30 conf="$GIT_DIR/gitweb/httpd.conf"
34 # if installed, it doesn't need further configuration (module_path)
35 test -z "$httpd" && httpd='lighttpd -f'
37 # any untaken local port will do...
38 test -z "$port" && port=1234
40 resolve_full_httpd () {
43 # ensure that the apache2/lighttpd command ends with "-f"
44 if ! echo "$httpd" | grep -- '-f *$' >/dev/null 2>&1
51 httpd_only="$(echo $httpd | cut -f1 -d' ')"
52 if case "$httpd_only" in /*) : ;; *) which $httpd_only >/dev/null;; esac
56 # many httpds are installed in /usr/sbin or /usr/local/sbin
57 # these days and those are not in most users $PATHs
58 # in addition, we may have generated a server script
59 # in $fqgitdir/gitweb.
60 for i in /usr/local/sbin /usr/sbin "$fqgitdir/gitweb"
62 if test -x "$i/$httpd_only"
69 echo >&2 "$httpd_only not found. Install $httpd_only or use" \
70 "--httpd to specify another httpd daemon."
76 # here $httpd should have a meaningful value
79 # don't quote $full_httpd, there can be arguments to it (-f)
80 $full_httpd "$fqgitdir/gitweb/httpd.conf"
82 echo "Could not execute http daemon $httpd."
88 test -f "$fqgitdir/pid" && kill $(cat "$fqgitdir/pid")
135 mkdir -p "$GIT_DIR/gitweb/tmp"
136 GIT_EXEC_PATH="$(git --exec-path)"
138 export GIT_EXEC_PATH GIT_DIR
142 # generate a standalone server script in $fqgitdir/gitweb.
143 cat >"$fqgitdir/gitweb/$httpd.rb" <<EOF
146 options = YAML::load_file(ARGV[0])
147 options[:StartCallback] = proc do
148 File.open(options[:PidFile],"w") do |f|
152 options[:ServerType] = WEBrick::Daemon
153 server = WEBrick::HTTPServer.new(options)
154 ['INT', 'TERM'].each do |signal|
155 trap(signal) {server.shutdown}
159 # generate a shell script to invoke the above ruby script,
160 # which assumes _ruby_ is in the user's $PATH. that's _one_
161 # portable way to run ruby, which could be installed anywhere,
163 cat >"$fqgitdir/gitweb/$httpd" <<EOF
165 exec ruby "$fqgitdir/gitweb/$httpd.rb" \$*
167 chmod +x "$fqgitdir/gitweb/$httpd"
171 :DocumentRoot: "$fqgitdir/gitweb"
172 :DirectoryIndex: ["gitweb.cgi"]
173 :PidFile: "$fqgitdir/pid"
175 test "$local" = true && echo ':BindAddress: "127.0.0.1"' >> "$conf"
180 server.document-root = "$fqgitdir/gitweb"
182 server.modules = ( "mod_cgi" )
183 server.indexfiles = ( "gitweb.cgi" )
184 server.pid-file = "$fqgitdir/pid"
185 cgi.assign = ( ".cgi" => "" )
186 mimetype.assign = ( ".css" => "text/css" )
188 test x"$local" = xtrue && echo 'server.bind = "127.0.0.1"' >> "$conf"
192 test -z "$module_path" && module_path=/usr/lib/apache2/modules
193 mkdir -p "$GIT_DIR/gitweb/logs"
195 test x"$local" = xtrue && bind='127.0.0.1:'
196 echo 'text/css css' > $fqgitdir/mime.types
198 ServerName "git-instaweb"
199 ServerRoot "$fqgitdir/gitweb"
200 DocumentRoot "$fqgitdir/gitweb"
201 PidFile "$fqgitdir/pid"
205 for mod in mime dir; do
206 if test -e $module_path/mod_${mod}.so; then
207 echo "LoadModule ${mod}_module " \
208 "$module_path/mod_${mod}.so" >> "$conf"
212 TypesConfig $fqgitdir/mime.types
213 DirectoryIndex gitweb.cgi
216 # check to see if Dennis Stosberg's mod_perl compatibility patch
217 # (<20060621130708.Gcbc6e5c@leonov.stosberg.net>) has been applied
218 if test -f "$module_path/mod_perl.so" && grep '^our $gitbin' \
219 "$GIT_DIR/gitweb/gitweb.cgi" >/dev/null
221 # favor mod_perl if available
223 LoadModule perl_module $module_path/mod_perl.so
225 PerlPassEnv GIT_EXEC_DIR
226 <Location /gitweb.cgi>
227 SetHandler perl-script
228 PerlResponseHandler ModPerl::Registry
229 PerlOptions +ParseHeaders
236 list_mods=$(echo "$full_httpd" | sed "s/-f$/-l/")
237 $list_mods | grep 'mod_cgi\.c' >/dev/null 2>&1 || \
238 echo "LoadModule cgi_module $module_path/mod_cgi.so" >> "$conf"
240 AddHandler cgi-script .cgi
241 <Location /gitweb.cgi>
249 s#^(my|our) \$projectroot =.*#$1 \$projectroot = "'$(dirname "$fqgitdir")'";#;
250 s#(my|our) \$gitbin =.*#$1 \$gitbin = "'$GIT_EXEC_PATH'";#;
251 s#(my|our) \$projects_list =.*#$1 \$projects_list = \$projectroot;#;
252 s#(my|our) \$git_temp =.*#$1 \$git_temp = "'$fqgitdir/gitweb/tmp'";#;'
255 cat > "$1.tmp" <<\EOFGITWEB
258 # Use the configured full path to perl to match the generated
259 # scripts' 'hashpling' line
260 "$PERL" -p -e "$script" "$1.tmp" > "$1"
266 cat > "$1" <<\EOFGITWEB
271 gitweb_cgi "$GIT_DIR/gitweb/gitweb.cgi"
272 gitweb_css "$GIT_DIR/gitweb/gitweb.css"
285 echo "Unknown httpd specified: $httpd"
291 url=http://127.0.0.1:$port
293 if test -n "$browser"; then
294 git web--browse -b "$browser" $url || echo $url
296 git web--browse -c "instaweb.browser" $url || echo $url